<template>
  <div>
    <div class="hero is-info is-fullheight">
      <form class="pipelineSelector" @submit.prevent="selectPipeline">
        <div class="hero-body">
          <div class="container">
            <h1 class="title">select you're description</h1>
          </div>
        </div>
        <div class="columns is-centered">
          <div class="column is-half">
            <div class="notification is-light">
              <figure class="image container is-128x128">
                <img class="image is-128x128" src="../assets/logo.png" />
              </figure>
              <div class="field">
                <label class="label">select you're pipeline</label>
                <ul id="pipelineSelector">
                  <li v-for="key of this.descriptions" :key="key.name">
                    <label class="checkbox">
                      <!-- n.b : pipeline.selected modifie le champs selected dans le store pour cette item-->
                      <input
                        type="checkbox"
                        v-model="key.selected"
                        v-on:click="select(key)"
                      />
                    </label>
                    <b> {{ key.name }} {{ key.version }}: </b>
                    {{ key.date }}
                  </li>
                </ul>
              </div>
              <button
                class="button is-primary is-rounded is-medium"
                type="submit"
              >
                next steep
              </button>
            </div>
          </div>
        </div>
      </form>
    </div>
    <div
      v-if="message"
      class="help"
      :class="successful ? 'is-success' : ' is-danger'"
    >
      {{ message }}
    </div>
  </div>
</template>

<script>
export default {
  name: "pipelineSelector",
  components: {},
  data: function() {
    return {
      message: "",
      sucessful: false,
      descriptions: []
    };
  },
  beforeMount() {
    this.$store.dispatch("pipeline/getDescriptions").then(
      descriptionMap => {
        // eslint-disable-next-line no-unused-vars
        for (let [key, value] of Object.entries(descriptionMap)) {
          // eslint-disable-next-line no-unused-vars
          for (let [key, value] of Object.entries(value)) {
            let date = new Date(value.creationDate);
            this.descriptions.push({
              name: value.name,
              version: value.version,
              date: `${date.getUTCDate()}/${date.getUTCMonth()}/${date.getUTCFullYear()}`,
              selected: false
            });
          }
        }
      },
      error => {
        this.message =
          (error.response && error.response.data) ||
          error.message ||
          error.toString();
      }
    );
  },
  methods: {
    selectPipeline() {
      for (let description of this.descriptions) {
        if (description.selected) {
          this.$router.push({
            name: "PipelineParameter",
            params: { name: description.name, version: description.version }
          });
        }
      }
    },
    /**
     * only one pipeline can be selected at the same time
     */
    select(selectedDescription) {
      for (let description of this.descriptions) {
        description.selected = false;
      }
      selectedDescription.selected = true;
    }
  }
};
</script>

<style css>
ul {
  text-align: left;
}
</style>
